Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class Collections

    java.lang.Object
      |
      +--java.util.Collections

public class Collections
extends Object

This class consists exclusively of static methods that operate on or return collections. It contains polymorphic algorithms that operate on collections, "wrappers", which return a new collection backed by a specified collection, and a few other odds and ends.

The documentation for the polymorphic algorithms contained in this class generally includes a brief description of the implementation. Such descriptions should be regarded as implementation notes, rather than parts of the specification. Implementors should feel free to substitute other algorithms, so long as the specification itself is adhered to. (For example, the algorithm used by `sort` does not have to be a mergesort, but it does have to be stable.)

Since:
  1.2
See Also:
  `Collection`, `Set`, `List`, `Map`

Field Summary
`static List` | `EMPTY_LIST` The empty list (immutable).
`static Map` | `EMPTY_MAP` The empty map (immutable).
`static Set` | `EMPTY_SET` The empty set (immutable).

Method Summary
`static int` | `binarySearch(List list, Object key)` Searches the specified list for the specified object using the binary search algorithm.
`static int` | `binarySearch(List list, Object key, Comparator c)` Searches the specified list for the specified object using the binary search algorithm.
`static void` | `copy(List dest, List src)` Copies all of the elements from one list into another.
`static Enumeration` | `enumeration(Collection c)` Returns an enumeration over the specified collection.
`static void` | `fill(List list, Object o)` Replaces all of the elements of the specified list with the specified element.
`static Object` | `max(Collection coll)` Returns the maximum element of the given collection, according to the natural ordering of its elements.
`static Object` | `max(Collection coll, Comparator comp)` Returns the maximum element of the given collection, according to the order induced by the specified comparator.
`static Object` | `min(Collection coll)` Returns the minimum element of the given collection, according to the natural ordering of its elements.
`static Object` | `min(Collection coll, Comparator comp)` Returns the minimum element of the given collection, according to the order induced by the specified comparator.
`static List` | `nCopies(int n, Object o)` Returns an immutable list consisting of `n` copies of the specified object.
`static void` | `reverse(List l)` Reverses the order of the elements in the specified list.
`static Comparator` | `reverseOrder()` Returns a comparator that imposes the reverse of the natural ordering on a collection of objects that implement the `Comparable` interface.
`static void` | `shuffle(List list)` Randomly permutes the specified list using a default source of randomness.
`static void` | `shuffle(List list, Random rnd)` Randomly permute the specified list using the specified source of randomness.
`static Set` | `singleton(Object o)` Returns an immutable set containing only the specified object.
`static List` | `singletonList(Object o)` Returns an immutable list containing only the specified object.
`static Map` | `singletonMap(Object key, Object value)` Returns an immutable map, mapping only the specified key to the specified value.
`static void` | `sort(List list)` Sorts the specified list into ascending order, according to the natural ordering of its elements.
`static void` | `sort(List list, Comparator c)` Sorts the specified list according to the order induced by the specified comparator.
`static Collection` | `synchronizedCollection(Collection c)` Returns a synchronized (thread-safe) collection backed by the specified collection.
`static List` | `synchronizedList(List list)` Returns a synchronized (thread-safe) list backed by the specified list.
`static Map` | `synchronizedMap(Map m)` Returns a synchronized (thread-safe) map backed by the specified map.
`static Set` | `synchronizedSet(Set s)` Returns a synchronized (thread-safe) set backed by the specified set.
`static SortedMap` | `synchronizedSortedMap(SortedMap m)` Returns a synchronized (thread-safe) sorted map backed by the specified sorted map.
`static SortedSet` | `synchronizedSortedSet(SortedSet s)` Returns a synchronized (thread-safe) sorted set backed by the specified sorted set.
`static Collection` | `unmodifiableCollection(Collection c)` Returns an unmodifiable view of the specified collection.
`static List` | `unmodifiableList(List list)` Returns an unmodifiable view of the specified list.
`static Map` | `unmodifiableMap(Map m)` Returns an unmodifiable view of the specified map.
`static Set` | `unmodifiableSet(Set s)` Returns an unmodifiable view of the specified set.
`static SortedMap` | `unmodifiableSortedMap(SortedMap m)` Returns an unmodifiable view of the specified sorted map.
`static SortedSet` | `unmodifiableSortedSet(SortedSet s)` Returns an unmodifiable view of the specified sorted set.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### EMPTY_SET

    public static final Set EMPTY_SET

  The empty set (immutable). This set is serializable.

### EMPTY_LIST

    public static final List EMPTY_LIST

  The empty list (immutable). This list is serializable.

### EMPTY_MAP

    public static final Map EMPTY_MAP

  The empty map (immutable). This map is serializable.
  Since:
    1.3

Method Detail

### sort

    public static void sort(List list)

  Sorts the specified list into ascending order, according to the natural ordering of its elements. All elements in the list must implement the `Comparable` interface. Furthermore, all elements in the list must be mutually comparable (that is, `e1.compareTo(e2)` must not throw a `ClassCastException` for any elements `e1` and `e2` in the list).

  This sort is guaranteed to be stable: equal elements will not be reordered as a result of the sort.

  The specified list must be modifiable, but need not be resizable.

  The sorting algorithm is a modified mergesort (in which the merge is omitted if the highest element in the low sublist is less than the lowest element in the high sublist). This algorithm offers guaranteed n log(n) performance, and can approach linear performance on nearly sorted lists.

  This implementation dumps the specified list into an array, sorts the array, and iterates over the list resetting each element from the corresponding position in the array. This avoids the n2 log(n) performance that would result from attempting to sort a linked list in place.

  Parameters:
    `list` - the list to be sorted.
  Throws:
    `ClassCastException` - if the list contains elements that are not mutually comparable (for example, strings and integers).
    `UnsupportedOperationException` - if the specified list's list-iterator does not support the `set` operation.
  See Also:
    `Comparable`

### sort

    public static void sort(List list,
                            Comparator c)

  Sorts the specified list according to the order induced by the specified comparator. All elements in the list must be mutually comparable using the specified comparator (that is, `c.compare(e1, e2)` must not throw a `ClassCastException` for any elements `e1` and `e2` in the list).

  This sort is guaranteed to be stable: equal elements will not be reordered as a result of the sort.

  The sorting algorithm is a modified mergesort (in which the merge is omitted if the highest element in the low sublist is less than the lowest element in the high sublist). This algorithm offers guaranteed n log(n) performance, and can approach linear performance on nearly sorted lists.

  The specified list must be modifiable, but need not be resizable. This implementation dumps the specified list into an array, sorts the array, and iterates over the list resetting each element from the corresponding position in the array. This avoids the n2 log(n) performance that would result from attempting to sort a linked list in place.

  Parameters:
    `list` - the list to be sorted.
    `c` - the comparator to determine the order of the list. A `null` value indicates that the elements' natural ordering should be used.
  Throws:
    `ClassCastException` - if the list contains elements that are not mutually comparable using the specified comparator.
    `UnsupportedOperationException` - if the specified list's list-iterator does not support the `set` operation.
  See Also:
    `Comparator`

### binarySearch

    public static int binarySearch(List list,
                                   Object key)

  Searches the specified list for the specified object using the binary search algorithm. The list must be sorted into ascending order according to the natural ordering of its elements (as by the `sort(List)` method, above) prior to making this call. If it is not sorted, the results are undefined. If the list contains multiple elements equal to the specified object, there is no guarantee which one will be found.

  This method runs in log(n) time for a "random access" list (which provides near-constant-time positional access). It may run in n log(n) time if it is called on a "sequential access" list (which provides linear-time positional access).

  If the specified list implements the `AbstracSequentialList` interface, this method will do a sequential search instead of a binary search; this offers linear performance instead of n log(n) performance if this method is called on a `LinkedList` object.
  Parameters:
    `list` - the list to be searched.
    `key` - the key to be searched for.
  Returns:
    index of the search key, if it is contained in the list; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the point at which the key would be inserted into the list: the index of the first element greater than the key, or `list.size()`, if all elements in the list are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  Throws:
    `ClassCastException` - if the list contains elements that are not mutually comparable (for example, strings and integers), or the search key in not mutually comparable with the elements of the list.
  See Also:
    `Comparable`, `sort(List)`

### binarySearch

    public static int binarySearch(List list,
                                   Object key,
                                   Comparator c)

  Searches the specified list for the specified object using the binary search algorithm. The list must be sorted into ascending order according to the specified comparator (as by the `Sort(List, Comparator)` method, above), prior to making this call. If it is not sorted, the results are undefined. If the list contains multiple elements equal to the specified object, there is no guarantee which one will be found.

  This method runs in log(n) time for a "random access" list (which provides near-constant-time positional access). It may run in n log(n) time if it is called on a "sequential access" list (which provides linear-time positional access).

  If the specified list implements the `AbstracSequentialList` interface, this method will do a sequential search instead of a binary search; this offers linear performance instead of n log(n) performance if this method is called on a `LinkedList` object.
  Parameters:
    `list` - the list to be searched.
    `key` - the key to be searched for.
    `c` - the comparator by which the list is ordered. A `null` value indicates that the elements' natural ordering should be used.
  Returns:
    index of the search key, if it is contained in the list; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the point at which the key would be inserted into the list: the index of the first element greater than the key, or `list.size()`, if all elements in the list are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
  Throws:
    `ClassCastException` - if the list contains elements that are not mutually comparable using the specified comparator, or the search key in not mutually comparable with the elements of the list using this comparator.
  See Also:
    `Comparable`, `sort(List, Comparator)`

### reverse

    public static void reverse(List l)

  Reverses the order of the elements in the specified list.

  This method runs in linear time.

  Parameters:
    `l` - the list whose elements are to be reversed.
  Throws:
    `UnsupportedOperationException` - if the specified list's list-iterator does not support the `set` operation.

### shuffle

    public static void shuffle(List list)

  Randomly permutes the specified list using a default source of randomness. All permutations occur with approximately equal likelihood.

  The hedge "approximately" is used in the foregoing description because default source of randomenss is only approximately an unbiased source of independently chosen bits. If it were a perfect source of randomly chosen bits, then the algorithm would choose permutations with perfect uniformity.

  This implementation traverses the list backwards, from the last element up to the second, repeatedly swapping a randomly selected element into the "current position". Elements are randomly selected from the portion of the list that runs from the first element to the current position, inclusive.

  This method runs in linear time for a "random access" list (which provides near-constant-time positional access). It may require quadratic time for a "sequential access" list.

  Parameters:
    `list` - the list to be shuffled.
  Throws:
    `UnsupportedOperationException` - if the specified list's list-iterator does not support the `set` operation.

### shuffle

    public static void shuffle(List list,
                               Random rnd)

  Randomly permute the specified list using the specified source of randomness. All permutations occur with equal likelihood assuming that the source of randomness is fair.

  This implementation traverses the list backwards, from the last element up to the second, repeatedly swapping a randomly selected element into the "current position". Elements are randomly selected from the portion of the list that runs from the first element to the current position, inclusive.

  This method runs in linear time for a "random access" list (which provides near-constant-time positional access). It may require quadratic time for a "sequential access" list.

  Parameters:
    `list` - the list to be shuffled.
    `rnd` - the source of randomness to use to shuffle the list.
  Throws:
    `UnsupportedOperationException` - if the specified list's list-iterator does not support the `set` operation.

### fill

    public static void fill(List list,
                            Object o)

  Replaces all of the elements of the specified list with the specified element.

  This method runs in linear time.

  Parameters:
    `list` - the list to be filled with the specified element.
    `o` - The element with which to fill the specified list.
  Throws:
    `UnsupportedOperationException` - if the specified list's list-iterator does not support the `set` operation.

### copy

    public static void copy(List dest,
                            List src)

  Copies all of the elements from one list into another. After the operation, the index of each copied element in the destination list will be identical to its index in the source list. The destination list must be at least as long as the source list. If it is longer, the remaining elements in the destination list are unaffected.

  This method runs in linear time.

  Parameters:
    `dest` - The destination list.
    `src` - The source list.
  Throws:
    `IndexOutOfBoundsException` - if the destination list is too small to contain the entire source List.
    `UnsupportedOperationException` - if the destination list's list-iterator does not support the `set` operation.

### min

    public static Object min(Collection coll)

  Returns the minimum element of the given collection, according to the natural ordering of its elements. All elements in the collection must implement the `Comparable` interface. Furthermore, all elements in the collection must be mutually comparable (that is, `e1.compareTo(e2)` must not throw a `ClassCastException` for any elements `e1` and `e2` in the collection).

  This method iterates over the entire collection, hence it requires time proportional to the size of the collection.

  Parameters:
    `coll` - the collection whose minimum element is to be determined.
  Returns:
    the minimum element of the given collection, according to the natural ordering of its elements.
  Throws:
    `ClassCastException` - if the collection contains elements that are not mutually comparable (for example, strings and integers).
    `NoSuchElementException` - if the collection is empty.
  See Also:
    `Comparable`

### min

    public static Object min(Collection coll,
                             Comparator comp)

  Returns the minimum element of the given collection, according to the order induced by the specified comparator. All elements in the collection must be mutually comparable by the specified comparator (that is, `comp.compare(e1, e2)` must not throw a `ClassCastException` for any elements `e1` and `e2` in the collection).

  This method iterates over the entire collection, hence it requires time proportional to the size of the collection.

  Parameters:
    `coll` - the collection whose minimum element is to be determined.
    `comp` - the comparator with which to determine the minimum element. A `null` value indicates that the elements' natural ordering should be used.
  Returns:
    the minimum element of the given collection, according to the specified comparator.
  Throws:
    `ClassCastException` - if the collection contains elements that are not mutually comparable using the specified comparator.
    `NoSuchElementException` - if the collection is empty.
  See Also:
    `Comparable`

### max

    public static Object max(Collection coll)

  Returns the maximum element of the given collection, according to the natural ordering of its elements. All elements in the collection must implement the `Comparable` interface. Furthermore, all elements in the collection must be mutually comparable (that is, `e1.compareTo(e2)` must not throw a `ClassCastException` for any elements `e1` and `e2` in the collection).

  This method iterates over the entire collection, hence it requires time proportional to the size of the collection.

  Parameters:
    `coll` - the collection whose maximum element is to be determined.
  Returns:
    the maximum element of the given collection, according to the natural ordering of its elements.
  Throws:
    `ClassCastException` - if the collection contains elements that are not mutually comparable (for example, strings and integers).
    `NoSuchElementException` - if the collection is empty.
  See Also:
    `Comparable`

### max

    public static Object max(Collection coll,
                             Comparator comp)

  Returns the maximum element of the given collection, according to the order induced by the specified comparator. All elements in the collection must be mutually comparable by the specified comparator (that is, `comp.compare(e1, e2)` must not throw a `ClassCastException` for any elements `e1` and `e2` in the collection).

  This method iterates over the entire collection, hence it requires time proportional to the size of the collection.

  Parameters:
    `coll` - the collection whose maximum element is to be determined.
    `comp` - the comparator with which to determine the maximum element. A `null` value indicates that the elements' natural ordering should be used.
  Returns:
    the maximum element of the given collection, according to the specified comparator.
  Throws:
    `ClassCastException` - if the collection contains elements that are not mutually comparable using the specified comparator.
    `NoSuchElementException` - if the collection is empty.
  See Also:
    `Comparable`

### unmodifiableCollection

    public static Collection unmodifiableCollection(Collection c)

  Returns an unmodifiable view of the specified collection. This method allows modules to provide users with "read-only" access to internal collections. Query operations on the returned collection "read through" to the specified collection, and attempts to modify the returned collection, whether direct or via its iterator, result in an `UnsupportedOperationException`.

  The returned collection does not pass the hashCode and equals operations through to the backing collection, but relies on `Object`'s `equals` and `hashCode` methods. This is necessary to preserve the contracts of these operations in the case that the backing collection is a set or a list.

  The returned collection will be serializable if the specified collection is serializable.

  Parameters:
    `c` - the collection for which an unmodifiable view is to be returned.
  Returns:
    an unmodifiable view of the specified collection.

### unmodifiableSet

    public static Set unmodifiableSet(Set s)

  Returns an unmodifiable view of the specified set. This method allows modules to provide users with "read-only" access to internal sets. Query operations on the returned set "read through" to the specified set, and attempts to modify the returned set, whether direct or via its iterator, result in an `UnsupportedOperationException`.

  The returned set will be serializable if the specified set is serializable.

  Parameters:
    `s` - the set for which an unmodifiable view is to be returned.
  Returns:
    an unmodifiable view of the specified set.

### unmodifiableSortedSet

    public static SortedSet unmodifiableSortedSet(SortedSet s)

  Returns an unmodifiable view of the specified sorted set. This method allows modules to provide users with "read-only" access to internal sorted sets. Query operations on the returned sorted set "read through" to the specified sorted set. Attempts to modify the returned sorted set, whether direct, via its iterator, or via its `subSet`, `headSet`, or `tailSet` views, result in an `UnsupportedOperationException`.

  The returned sorted set will be serializable if the specified sorted set is serializable.

  Parameters:
    `s` - the sorted set for which an unmodifiable view is to be returned.
  Returns:
    an unmodifiable view of the specified sorted set.

### unmodifiableList

    public static List unmodifiableList(List list)

  Returns an unmodifiable view of the specified list. This method allows modules to provide users with "read-only" access to internal lists. Query operations on the returned list "read through" to the specified list, and attempts to modify the returned list, whether direct or via its iterator, result in an `UnsupportedOperationException`.

  The returned list will be serializable if the specified list is serializable.

  Parameters:
    `list` - the list for which an unmodifiable view is to be returned.
  Returns:
    an unmodifiable view of the specified list.

### unmodifiableMap

    public static Map unmodifiableMap(Map m)

  Returns an unmodifiable view of the specified map. This method allows modules to provide users with "read-only" access to internal maps. Query operations on the returned map "read through" to the specified map, and attempts to modify the returned map, whether direct or via its collection views, result in an `UnsupportedOperationException`.

  The returned map will be serializable if the specified map is serializable.

  Parameters:
    `m` - the map for which an unmodifiable view is to be returned.
  Returns:
    an unmodifiable view of the specified map.

### unmodifiableSortedMap

    public static SortedMap unmodifiableSortedMap(SortedMap m)

  Returns an unmodifiable view of the specified sorted map. This method allows modules to provide users with "read-only" access to internal sorted maps. Query operations on the returned sorted map "read through" to the specified sorted map. Attempts to modify the returned sorted map, whether direct, via its collection views, or via its `subMap`, `headMap`, or `tailMap` views, result in an `UnsupportedOperationException`.

  The returned sorted map will be serializable if the specified sorted map is serializable.

  Parameters:
    `m` - the sorted map for which an unmodifiable view is to be returned.
  Returns:
    an unmodifiable view of the specified sorted map.

### synchronizedCollection

    public static Collection synchronizedCollection(Collection c)

  Returns a synchronized (thread-safe) collection backed by the specified collection. In order to guarantee serial access, it is critical that all access to the backing collection is accomplished through the returned collection.

  It is imperative that the user manually synchronize on the returned collection when iterating over it:

        Collection c = Collections.synchronizedCollection(myCollection);
           ...
        synchronized(c) {
            Iterator i = c.iterator(); // Must be in the synchronized block
            while (i.hasNext())
               foo(i.next());
        }

  Failure to follow this advice may result in non-deterministic behavior.

  The returned collection does not pass the `hashCode` and `equals` operations through to the backing collection, but relies on `Object`'s equals and hashCode methods. This is necessary to preserve the contracts of these operations in the case that the backing collection is a set or a list.

  The returned collection will be serializable if the specified collection is serializable.

  Parameters:
    `c` - the collection to be "wrapped" in a synchronized collection.
  Returns:
    a synchronized view of the specified collection.

### synchronizedSet

    public static Set synchronizedSet(Set s)

  Returns a synchronized (thread-safe) set backed by the specified set. In order to guarantee serial access, it is critical that all access to the backing set is accomplished through the returned set.

  It is imperative that the user manually synchronize on the returned set when iterating over it:

        Set s = Collections.synchronizedSet(new HashSet());
            ...
        synchronized(s) {
            Iterator i = s.iterator(); // Must be in the synchronized block
            while (i.hasNext())
                foo(i.next());
        }

  Failure to follow this advice may result in non-deterministic behavior.

  The returned set will be serializable if the specified set is serializable.

  Parameters:
    `s` - the set to be "wrapped" in a synchronized set.
  Returns:
    a synchronized view of the specified set.

### synchronizedSortedSet

    public static SortedSet synchronizedSortedSet(SortedSet s)

  Returns a synchronized (thread-safe) sorted set backed by the specified sorted set. In order to guarantee serial access, it is critical that all access to the backing sorted set is accomplished through the returned sorted set (or its views).

  It is imperative that the user manually synchronize on the returned sorted set when iterating over it or any of its `subSet`, `headSet`, or `tailSet` views.

        SortedSet s = Collections.synchronizedSortedSet(new HashSortedSet());
            ...
        synchronized(s) {
            Iterator i = s.iterator(); // Must be in the synchronized block
            while (i.hasNext())
                foo(i.next());
        }

  or:

        SortedSet s = Collections.synchronizedSortedSet(new HashSortedSet());
        SortedSet s2 = s.headSet(foo);
            ...
        synchronized(s) {  // Note: s, not s2!!!
            Iterator i = s2.iterator(); // Must be in the synchronized block
            while (i.hasNext())
                foo(i.next());
        }

  Failure to follow this advice may result in non-deterministic behavior.

  The returned sorted set will be serializable if the specified sorted set is serializable.

  Parameters:
    `s` - the sorted set to be "wrapped" in a synchronized sorted set.
  Returns:
    a synchronized view of the specified sorted set.

### synchronizedList

    public static List synchronizedList(List list)

  Returns a synchronized (thread-safe) list backed by the specified list. In order to guarantee serial access, it is critical that all access to the backing list is accomplished through the returned list.

  It is imperative that the user manually synchronize on the returned list when iterating over it:

        List list = Collections.synchronizedList(new ArrayList());
            ...
        synchronized(list) {
            Iterator i = list.iterator(); // Must be in synchronized block
            while (i.hasNext())
                foo(i.next());
        }

  Failure to follow this advice may result in non-deterministic behavior.

  The returned list will be serializable if the specified list is serializable.

  Parameters:
    `list` - the list to be "wrapped" in a synchronized list.
  Returns:
    a synchronized view of the specified list.

### synchronizedMap

    public static Map synchronizedMap(Map m)

  Returns a synchronized (thread-safe) map backed by the specified map. In order to guarantee serial access, it is critical that all access to the backing map is accomplished through the returned map.

  It is imperative that the user manually synchronize on the returned map when iterating over any of its collection views:

        Map m = Collections.synchronizedMap(new HashMap());
            ...
        Set s = m.keySet();  // Needn't be in synchronized block
            ...
        synchronized(m) {  // Synchronizing on m, not s!
            Iterator i = s.iterator(); // Must be in synchronized block
            while (i.hasNext())
                foo(i.next());
        }

  Failure to follow this advice may result in non-deterministic behavior.

  The returned map will be serializable if the specified map is serializable.

  Parameters:
    `m` - the map to be "wrapped" in a synchronized map.
  Returns:
    a synchronized view of the specified map.

### synchronizedSortedMap

    public static SortedMap synchronizedSortedMap(SortedMap m)

  Returns a synchronized (thread-safe) sorted map backed by the specified sorted map. In order to guarantee serial access, it is critical that all access to the backing sorted map is accomplished through the returned sorted map (or its views).

  It is imperative that the user manually synchronize on the returned sorted map when iterating over any of its collection views, or the collections views of any of its `subMap`, `headMap` or `tailMap` views.

        SortedMap m = Collections.synchronizedSortedMap(new HashSortedMap());
            ...
        Set s = m.keySet();  // Needn't be in synchronized block
            ...
        synchronized(m) {  // Synchronizing on m, not s!
            Iterator i = s.iterator(); // Must be in synchronized block
            while (i.hasNext())
                foo(i.next());
        }

  or:

        SortedMap m = Collections.synchronizedSortedMap(new HashSortedMap());
        SortedMap m2 = m.subMap(foo, bar);
            ...
        Set s2 = m2.keySet();  // Needn't be in synchronized block
            ...
        synchronized(m) {  // Synchronizing on m, not m2 or s2!
            Iterator i = s.iterator(); // Must be in synchronized block
            while (i.hasNext())
                foo(i.next());
        }

  Failure to follow this advice may result in non-deterministic behavior.

  The returned sorted map will be serializable if the specified sorted map is serializable.

  Parameters:
    `m` - the sorted map to be "wrapped" in a synchronized sorted map.
  Returns:
    a synchronized view of the specified sorted map.

### singleton

    public static Set singleton(Object o)

  Returns an immutable set containing only the specified object. The returned set is serializable.
  Parameters:
    `o` - the sole object to be stored in the returned set.
  Returns:
    an immutable set containing only the specified object.

### singletonList

    public static List singletonList(Object o)

  Returns an immutable list containing only the specified object. The returned list is serializable.
  Parameters:
    `o` - the sole object to be stored in the returned list.
  Returns:
    an immutable list containing only the specified object.
  Since:
    1.3

### singletonMap

    public static Map singletonMap(Object key,
                                   Object value)

  Returns an immutable map, mapping only the specified key to the specified value. The returned map is serializable.
  Parameters:
    `key` - the sole key to be stored in the returned map.
    `value` - the value to which the returned map maps `key`.
  Returns:
    an immutable map containing only the specified key-value mapping.
  Since:
    1.3

### nCopies

    public static List nCopies(int n,
                               Object o)

  Returns an immutable list consisting of `n` copies of the specified object. The newly allocated data object is tiny (it contains a single reference to the data object). This method is useful in combination with the `List.addAll` method to grow lists. The returned list is serializable.
  Parameters:
    `n` - the number of elements in the returned list.
    `o` - the element to appear repeatedly in the returned list.
  Returns:
    an immutable list consisting of `n` copies of the specified object.
  Throws:
    `IllegalArgumentException` - if n < 0.
  See Also:
    `List.addAll(Collection)`, `List.addAll(int, Collection)`

### reverseOrder

    public static Comparator reverseOrder()

  Returns a comparator that imposes the reverse of the natural ordering on a collection of objects that implement the `Comparable` interface. (The natural ordering is the ordering imposed by the objects' own `compareTo` method.) This enables a simple idiom for sorting (or maintaining) collections (or arrays) of objects that implement the `Comparable` interface in reverse-natural-order. For example, suppose a is an array of strings. Then:

       		Arrays.sort(a, Collections.reverseOrder());

  sorts the array in reverse-lexicographic (alphabetical) order.

  The returned comparator is serializable.

  Returns:
    a comparator that imposes the reverse of the natural ordering on a collection of objects that implement the `Comparable` interface.
  See Also:
    `Comparable`

### enumeration

    public static Enumeration enumeration(Collection c)

  Returns an enumeration over the specified collection. This provides interoperatbility with legacy APIs that require an enumeration as input.
  Parameters:
    `c` - the collection for which an enumeration is to be returned.
  Returns:
    an enumeration over the specified collection.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.